import{jsx as _jsx,jsxs as _jsxs,Fragment as _Fragment}from"react/jsx-runtime";import{useState,useEffect,useContext,useRef}from"react";import{auth}from"../firebaseConfig";import{signOut,onAuthStateChanged}from"firebase/auth";import{signInWithEmailAndPassword,createUserWithEmailAndPassword}from"firebase/auth";import{Button,Box,TextField,Popper,Typography,Snackbar,Alert,Stack,Switch,ClickAwayListener}from"@mui/material";import LogoutIcon from"@mui/icons-material/Logout";import{useTheme}from"@mui/material/styles";import useMediaQuery from"@mui/material/useMediaQuery";import{doc,setDoc,getFirestore,getDoc}from"firebase/firestore";import{UserContext}from"../UserContext";import{usePopper}from"../PopperContext";const Login=({showPopper,company})=>{const{user,setUser,setLoading}=useContext(UserContext);const{formToShow,setFormToShow}=usePopper();const[email,setEmail]=useState("");const[password,setPassword]=useState("");const[isWorker,setIsWorker]=useState(false);const[isCompany,setIsCompany]=useState(true);const[errorMessage,setErrorMessage]=useState("");const[anchorEl,setAnchorEl]=useState(null);const loginButtonRef=useRef(null);const signUpButtonRef=useRef(null);const theme=useTheme();const isSmallScreen=useMediaQuery(theme.breakpoints.down("sm"));useEffect(()=>{const unsubscribe=onAuthStateChanged(auth,user=>{const fetchUser=async()=>{if(user){const docRef=doc(db,"users",user.uid);const docSnap=await getDoc(docRef);if(docSnap.exists()){const data=docSnap.data();if(data&&data.isCompany){setUser({...user,isCompany:data.isCompany})}}else{console.log("No user document!")}}else{setUser(null)}setLoading(false);setEmail("");setPassword("");setErrorMessage("")};fetchUser()});if(!auth.currentUser){setLoading(false)}return()=>unsubscribe()},[]);useEffect(()=>{setFormToShow(showPopper?"signup":"none");if(company){setIsWorker(true);setIsCompany(false)}},[showPopper]);const signIn=async()=>{setFormToShow("none");setAnchorEl(null);try{await signInWithEmailAndPassword(auth,email,password);console.log("User signed in successfully.")}catch(error){if(error instanceof Error){const firebaseError=error;switch(firebaseError.code){case"auth/invalid-credential":setErrorMessage("Invalid user or password.");break;case"auth/invalid-email":setErrorMessage("Invalid email.");break;default:setErrorMessage("Unknown error.")}setOpen(true);console.log(firebaseError.code)}}};const db=getFirestore();const signUp=async()=>{setFormToShow("none");setAnchorEl(null);try{const userCredential=await createUserWithEmailAndPassword(auth,email,password);await setDoc(doc(db,"users",userCredential.user.uid),{email:email,isWorker:isWorker,isCompany:isCompany,company:company})}catch(error){if(error instanceof Error){const firebaseError=error;console.log(email,password);switch(firebaseError.code){case"auth/email-already-in-use":setErrorMessage("Email already in use.");break;case"auth/weak-password":setErrorMessage("Weak password (6 characters).");break;case"auth/invalid-email":setErrorMessage("Invalid email.");break;case"auth/invalid-credential":setErrorMessage("Wrong password.");break;default:setErrorMessage("S'ha produït un error desconegut.")}setOpen(true);console.log(firebaseError.code)}}};const logout=async()=>{try{await signOut(auth);setUser(null);console.log("User signed out successfully.")}catch(error){console.log("Error signing out:",error)}};const[open,setOpen]=useState(false);const handleClose=(_,reason)=>{if(reason==="clickaway"){return}setOpen(false)};const handleAlertClose=event=>{handleClose(event,"timeout")};const handleSwitchChange=event=>{setIsWorker(event.target.checked);setIsCompany(!event.target.checked)};return _jsxs(_Fragment,{children:[_jsx(Snackbar,{open:open,autoHideDuration:6e3,onClose:handleClose,anchorOrigin:{vertical:"top",horizontal:"center"},children:_jsx(Alert,{onClose:handleAlertClose,severity:"error",sx:{width:"100%"},children:errorMessage})}),!user?_jsxs(Box,{sx:{display:"flex",alignItems:"stretch"},children:[_jsx(Button,{ref:loginButtonRef,color:"inherit",sx:{display:"flex",alignItems:"center",height:"100%"},onClick:e=>{setFormToShow("login");setAnchorEl(e.currentTarget)},children:"Login"}),_jsxs(Button,{ref:signUpButtonRef,color:"inherit",sx:{display:"flex",alignItems:"center",height:"100%",lineHeight:1.3},onClick:e=>{setFormToShow("signup");setAnchorEl(e.currentTarget)},children:["Create ",_jsx("br",{})," Account"]})]}):_jsxs(Box,{gap:2,sx:{display:"flex",flexDirection:"row",alignItems:"center"},children:[_jsx(Typography,{children:user.email}),_jsx(Button,{children:_jsx(LogoutIcon,{onClick:logout,sx:{color:"white"}})})]}),_jsx(ClickAwayListener,{onClickAway:event=>{if(event.target!==loginButtonRef.current&&event.target!==signUpButtonRef.current){setFormToShow("none")}},children:_jsx(Popper,{open:formToShow==="login"||formToShow==="signup",anchorEl:isSmallScreen?null:anchorEl,placement:isSmallScreen?"bottom":"bottom-end",sx:{boxShadow:5,padding:"40px",width:isSmallScreen?"70vw":"340px",backgroundColor:"white",top:isSmallScreen?"70px!important":"20px!important",left:isSmallScreen?"5vw!important":"auto"},children:_jsxs(Box,{component:"form",sx:{backgroundColor:"white",width:"100%",display:"flex",flexDirection:"column",padding:0,gap:2},padding:5,onSubmit:e=>{console.log("test");e.preventDefault();if(formToShow==="login"){console.log("signing in");signIn()}else if(formToShow==="signup"){signUp()}},children:[_jsx(TextField,{required:true,id:"email_login",label:"Email",value:email,onChange:e=>setEmail(e.target.value)}),_jsx(TextField,{required:true,id:"password_login",label:"Password",type:"password",value:password,onChange:e=>setPassword(e.target.value)}),formToShow==="signup"&&company===null&&_jsxs(Stack,{direction:"row",spacing:1,alignItems:"center",justifyContent:"center",children:[_jsx(Typography,{fontSize:14,fontWeight:isCompany?700:400,children:"Company"}),_jsx(Switch,{defaultChecked:false,inputProps:{"aria-label":"ant design"},onChange:handleSwitchChange}),_jsx(Typography,{fontSize:14,fontWeight:isWorker?700:400,children:"Worker"})]}),_jsx(Button,{type:"submit",onClick:formToShow==="login"?signIn:signUp,children:formToShow==="login"?"Sign In":"Create Account"})]})})})]})};export{Login,auth};