import{jsx as _jsx,jsxs as _jsxs}from"react/jsx-runtime";import React,{useEffect,useState,useContext}from"react";import{UserContext}from"../UserContext";import{Button,Grid,Typography}from"@mui/material";import{formatTime}from"../utils/timeUtils";import{getDoc,doc,setDoc,Timestamp,collection,query,where,getDocs,orderBy}from"firebase/firestore";import{db}from"../firebaseConfig";import TimerLog from"./TimerLog";import{startOfWeek,endOfWeek}from"date-fns";const Timer=()=>{const[startTime,setStartTime]=useState(null);const[endTime,setEndTime]=useState(null);const[startPause,setStartPause]=useState(null);const[endPause,setEndPause]=useState(null);const[workedTime,setWorkedTime]=useState(0);const[pausedTime,setPausedTime]=useState(0);const[isWorking,setIsWorking]=useState(false);const[isResting,setIsResting]=useState(false);const[weekData,setWeekData]=useState([]);const{user}=useContext(UserContext);useEffect(()=>{let interval=null;if(isWorking){interval=setInterval(()=>{const now=new Date;if(startTime){const workDiff=Math.floor((now.getTime()-startTime.getTime())/1e3)-pausedTime;setWorkedTime(workDiff)}},1e3)}else if(interval){clearInterval(interval)}return()=>{if(interval){clearInterval(interval)}}},[startTime,isWorking]);useEffect(()=>{let interval=null;if(isResting){interval=setInterval(()=>{const now=new Date;if(startPause){const pauseDiff=Math.floor((now.getTime()-startPause.getTime())/1e3);setPausedTime(pauseDiff)}},1e3)}else if(interval){clearInterval(interval)}return()=>{if(interval){clearInterval(interval)}}},[startPause,isResting]);useEffect(()=>{if(startTime){saveDataToFirestore()}},[startTime,endTime,startPause,endPause,workedTime,pausedTime]);const saveDataToFirestore=async()=>{if(!user){return}const timerData={date:startTime?Timestamp.fromDate(startTime):null,startTime:startTime?Timestamp.fromDate(startTime):null,endTime:endTime?Timestamp.fromDate(endTime):null,startPause:startPause?Timestamp.fromDate(startPause):null,endPause:endPause?Timestamp.fromDate(endPause):null,workedTime,pausedTime};const docId=startTime?startTime.toISOString().split("T")[0]:new Date().toISOString().split("T")[0];const docRef=doc(db,"users",user.uid,"timerData",docId);await setDoc(docRef,timerData,{merge:true})};const startOfWeekDate=startOfWeek(new Date,{weekStartsOn:1});const endOfWeekDate=endOfWeek(new Date,{weekStartsOn:1});const startOfWeekDateUTC=new Date(Date.UTC(startOfWeekDate.getUTCFullYear(),startOfWeekDate.getUTCMonth(),startOfWeekDate.getUTCDate()));const endOfWeekDateUTC=new Date(Date.UTC(endOfWeekDate.getUTCFullYear(),endOfWeekDate.getUTCMonth(),endOfWeekDate.getUTCDate(),23,59,59));useEffect(()=>{const fetchData=async userId=>{const docId=new Date().toISOString().split("T")[0];const docRef=doc(db,"users",userId,"timerData",docId);const docSnap=await getDoc(docRef);console.log(docSnap);if(docSnap.exists()){const data=docSnap.data();setStartTime(data.startTime?.toDate()||null);setEndTime(data.endTime?.toDate()||null);setStartPause(data.startPause?.toDate()||null);setEndPause(data.endPause?.toDate()||null);setWorkedTime(data.workedTime||0);setPausedTime(data.pausedTime||0);if(data.startTime&&!data.endTime&&(!data.startPause||data.endPause)){setIsWorking(true)}if(data.startPause&&!data.endPause){setIsResting(true)}setWorkedTime(data.workedTime);setPausedTime(data.pausedTime)}};const fetchDataForWeek=async userId=>{if(!userId){setWeekData([]);return}const q=query(collection(db,"users",userId,"timerData"),where("date",">=",startOfWeekDateUTC),where("date","<=",endOfWeekDateUTC),orderBy("date"));try{const querySnapshot=await getDocs(q);const weekData=querySnapshot.docs.map((doc,index)=>{const data=doc.data();return{id:index,date:data.date.toDate(),startTime:data.startTime?.toDate(),endTime:data.endTime?.toDate(),startPause:data.startPause?.toDate(),endPause:data.endPause?.toDate(),workedTime:data.workedTime,pausedTime:data.pausedTime}});setWeekData(weekData)}catch(error){console.error("Error fetching data for week:",error)}};if(user){fetchData(user.uid);fetchDataForWeek(user.uid)}else{setWeekData([])}},[user]);return _jsxs(Grid,{container:true,justifyContent:"center",textAlign:"center",padding:5,sx:{paddingTop:"150px"},children:[_jsxs(Grid,{xs:12,sm:6,container:true,item:true,spacing:2,direction:"column",children:[_jsx(Grid,{item:true,children:_jsx(Typography,{children:formatTime(workedTime)})}),_jsx(Grid,{item:true,children:!startTime?_jsx(Button,{variant:"contained",onClick:()=>{setStartTime(new Date);setIsWorking(true)},children:"Start day"}):_jsx(Button,{onClick:()=>{setIsWorking(false);setIsResting(false);setEndTime(new Date);{!endPause?setEndPause(new Date):null}},children:"End day"})}),_jsx(Grid,{item:true,children:startTime&&_jsxs(Typography,{children:["start time: ",startTime?.toLocaleTimeString()]})}),_jsx(Grid,{item:true,children:endTime&&_jsxs(Typography,{children:["end time: ",endTime?.toLocaleTimeString()]})})]}),_jsxs(Grid,{xs:12,sm:6,container:true,item:true,spacing:2,direction:"column",children:[_jsx(Grid,{item:true,children:pausedTime?formatTime(pausedTime):"00:00:00"}),_jsx(Grid,{item:true,children:!startPause?_jsx(Button,{variant:"contained",onClick:()=>{setStartPause(new Date);setIsWorking(false);setIsResting(true)},children:"Start pause"}):_jsx(Button,{onClick:()=>{setIsWorking(true);setIsResting(false);setEndPause(new Date)},children:"End pause"})}),_jsx(Grid,{item:true,children:startPause&&_jsxs(Typography,{children:["start pause: ",startPause?.toLocaleTimeString()]})}),_jsx(Grid,{item:true,children:endPause&&_jsxs(Typography,{children:["end pause: ",endPause?.toLocaleTimeString()]})})]}),_jsxs(Grid,{container:true,direction:"column",xs:12,item:true,padding:5,marginTop:5,spacing:1,children:[_jsx(Grid,{item:true,children:_jsxs(Typography,{children:["worked time: ",formatTime(workedTime)]})}),_jsx(Grid,{item:true,children:_jsxs(Typography,{children:["paused time: ",formatTime(pausedTime)]})})]}),user&&_jsx(TimerLog,{rows:weekData})]})};export default Timer;